Blabber = LCS.class({playing = false, counter = 1})
function Blabber:init(text, base_pitch, filename)
	self.text=text
	self.base_pitch=base_pitch
	self.filename=filename
	self.source = love.audio.newSource(filename, "static")
	self.source:setLooping(false)
	-- TODO: Find out how long the file is or maybe have it hardcoded.
	-- TODO: clean text.
end

-- This starts playing the blabber, mostly by setting the "playing" flag to true.
function Blabber:play()
	self.playing = true
	self.counter = 1
	self:blab(self.counter)
end

function Blabber:get_pitch(char)
	return (string.byte(char, 1) % 27) / 27
end

-- Do one cycle.
function Blabber:blab(location)
	-- Where location is the current char.
	-- For now it just plays the sound

	-- Pitch will be based on a mapping of certain letters to certain pitches. That pitch will be added/multiplied by the base pitch.
	print("Blabbing. Location: " .. location .. " (" .. string.sub(self.text, location, location) .. ")")
	-- Now it's time to set the pitch.
	self.source:setPitch(self.base_pitch * self:get_pitch(string.sub(self.text, location, location)))
	self.source:play()
end

-- This function is called every update cycle.
function Blabber:update(dt)
	if not self.playing then return end
	if self.source:isStopped() then -- There is a bug here. For some reason it does not detect when the sound source has finished playing... Will have to investigate.
		-- Now we know that it has stopped playing.
		self.counter = self.counter + 1
		if self.counter <= #self.text then
			self:blab(self.counter)
		else
			self.playing = false
		end
	end
end
