lg = love.graphics
lm = love.mouse
lk = love.keyboard

LCS = require "Lua-Class-System/LCS"

require "utils"
require "fonts"
require "Scheduler"
require "SoundManager"
require "Blabber"
-- require "Classes/all"
-- require "States/all"
-- require "debug_overlay"



function love.load()
	lg.setDefaultImageFilter("nearest", "nearest")
	lm.setVisible(false)
	soundmanager = SoundManager()
	-- Set default font.
	lg.setFont(fonts.neshoret16)
	base_pitch = 1
end

function love.draw()
	lg.print("Press b to test the blabber function with string \"Testing\".\nPress a to test with string \"aaaa\"", 20,20)
	lg.print("Base pitch: " .. base_pitch .. "\nChange it with the plus and minus keys", 20, 120)
end

function love.update(dt)
	soundmanager:update(dt)
end

function love.keypressed(key, unicode)

	if key == "b" then
		local text= "Testing"
		print("Blabbing: " .. text)
		soundmanager:add_blab(text, base_pitch, nil, true)
	end
	if key == "a" then
		local text= "aaaa"
		print("Blabbing: " .. text)
		soundmanager:add_blab(text, base_pitch, nil, true)
	end

	if key == "-" then base_pitch = base_pitch - 0.1 end
	if key == "=" then base_pitch = base_pitch + 0.1 end
end

function love.keyreleased(key, unicode)

end
