-- This file contains various useful things that didn't quite
-- make it to other files. Tidbits.

-- Clamp function:
-- math.clamp(x, n, y) => x<n<y
function math.clamp(low, n, high) return math.min(math.max(n, low), high) end

-- Normalization function:
function math.normalize_rad(deg)
	if deg < 0 then return (math.pi*2) + deg end
	if deg > (math.pi*2) then return deg % (math.pi*2) end
	return deg
end

function deepcopy(orig)
	local orig_type = type(orig)
	local copy
	if orig_type == 'table' then
		copy = {}
		for orig_key, orig_value in next, orig, nil do
			copy[deepcopy(orig_key)] = deepcopy(orig_value)
		end
		setmetatable(copy, deepcopy(getmetatable(orig)))
	else -- number, string, boolean, etc
		copy = orig
	end
	return copy
end

function table.search(tab, obj)
	for idx, elm in ipairs(tab) do
		if elm == obj then
			return idx
		end
	end
	return nil
end